# ==============================================================================
# Copyright (C) 2019 - Philip Paquette
#
#  This program is free software: you can redistribute it and/or modify it under
#  the terms of the GNU Affero General Public License as published by the Free
#  Software Foundation, either version 3 of the License, or (at your option) any
#  later version.
#
#  This program is distributed in the hope that it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more
#  details.
#
#  You should have received a copy of the GNU Affero General Public License along
#  with this program.  If not, see <https://www.gnu.org/licenses/>.
# ==============================================================================
""" Error
    - Contains the error messages used by the engine
"""
MAP_LEAST_TWO_POWERS = 'MAP DOES NOT SPECIFY AT LEAST TWO POWERS'
MAP_LOC_NOT_FOUND = 'NAMED LOCATION NOT ON MAP: %s'
MAP_SITE_ABUTS_TWICE = 'SITES ABUT TWICE %s-%s'
MAP_NO_FULL_NAME = 'MAP LOCATION HAS NO FULL NAME: %s'
MAP_ONE_WAY_ADJ = 'ONE-WAY ADJACENCY IN MAP: %s -> %s'
MAP_BAD_HOME = 'BAD HOME FOR %s: %s'
MAP_BAD_INITIAL_OWN_CENTER = 'BAD INITIAL OWNED CENTER FOR %s: %s'
MAP_BAD_INITIAL_UNITS = 'BAD INITIAL UNIT FOR %s: %s'
MAP_CENTER_MULT_OWNED = 'CENTER MULTIPLY OWNED: %s'
MAP_BAD_PHASE = 'BAD PHASE IN MAP FILE: %s'
MAP_FILE_NOT_FOUND = 'MAP FILE NOT FOUND: %s'
MAP_BAD_VICTORY_LINE = 'BAD VICTORY LINE IN MAP FILE'
MAP_BAD_ROOT_MAP_LINE = 'BAD ROOT MAP LINE'
MAP_TWO_ROOT_MAPS = 'TWO ROOT MAPS'
MAP_FILE_MULT_USED = 'FILE MULTIPLY USED: %s'
MAP_BAD_ALIASES_IN_FILE = 'BAD ALIASES IN MAP FILE: %s'
MAP_RENAME_NOT_SUPPORTED = 'THE RENAME PLACE OPERATOR -> IS NO LONGER SUPPORTED.'
MAP_BAD_RENAME_DIRECTIVE = 'BAD RENAME DIRECTIVE: %s'
MAP_INVALID_LOC_ABBREV = 'INVALID LOCATION ABBREVIATION: %s'
MAP_LOC_RESERVED_KEYWORD = 'MAP LOCATION IS RESERVED KEYWORD: %s'
MAP_DUP_LOC_OR_POWER = 'DUPLICATE MAP LOCATION OR POWER: %s'
MAP_DUP_ALIAS_OR_POWER = 'DUPLICATE MAP ALIAS OR POWER: %s'
MAP_OWNS_BEFORE_POWER = '%s BEFORE POWER: %s'
MAP_INHABITS_BEFORE_POWER = 'INHABITS BEFORE POWER: %s'
MAP_HOME_BEFORE_POWER = '%s BEFORE POWER: %s'
MAP_UNITS_BEFORE_POWER = 'UNITS BEFORE POWER'
MAP_UNIT_BEFORE_POWER = 'UNIT BEFORE POWER: %s'
MAP_INVALID_UNIT = 'INVALID UNIT: %s'
MAP_DUMMY_REQ_LIST_POWERS = 'DUMMIES REQUIRES LIST OF POWERS'
MAP_DUMMY_BEFORE_POWER = 'DUMMY BEFORE POWER'
MAP_NO_EXCEPT_AFTER_DUMMY_ALL = 'NO EXCEPT AFTER %s ALL'
MAP_NO_POWER_AFTER_DUMMY_ALL_EXCEPT = 'NO POWER AFTER %s ALL EXCEPT'
MAP_NO_DATA_TO_AMEND_FOR = 'NO DATA TO "AMEND" FOR %s'
MAP_NO_ABUTS_FOR = 'NO "ABUTS" FOR %s'
MAP_UNPLAYED_BEFORE_POWER = 'UNPLAYED BEFORE POWER'
MAP_NO_EXCEPT_AFTER_UNPLAYED_ALL = 'NO EXCEPT AFTER UNPLAYED ALL'
MAP_NO_POWER_AFTER_UNPLAYED_ALL_EXCEPT = 'NO POWER AFTER UNPLAYED ALL EXCEPT'
MAP_NO_SUCH_POWER_TO_REMOVE = 'NO SUCH POWER TO REMOVE: %s'
MAP_RENAMING_UNOWNED_DIR_NOT_ALLOWED = 'RENAMING UNOWNED DIRECTIVE NOT ALLOWED'
MAP_RENAMING_UNDEF_POWER = 'RENAMING UNDEFINED POWER %s'
MAP_RENAMING_POWER_NOT_SUPPORTED = 'THE RENAME POWER OPERATOR -> IS NO LONGER SUPPORTED.'
MAP_POWER_NAME_EMPTY_KEYWORD = 'POWER NAME IS EMPTY KEYWORD: %s'
MAP_POWER_NAME_CAN_BE_CONFUSED = 'POWER NAME CAN BE CONFUSED WITH LOCATION ALIAS OR ORDER TYPE: %s'
MAP_ILLEGAL_POWER_ABBREV = 'ILLEGAL POWER ABBREVIATION'

GAME_UNKNOWN_POWER = 'UNKNOWN POWER OR PLACENAME: %s'
GAME_UNKNOWN_UNIT_TYPE = 'UNKNOWN UNIT TYPE: %s'
GAME_UNKNOWN_LOCATION = 'UNKNOWN PLACENAME: %s'
GAME_UNKNOWN_COAST = 'UNKNOWN COAST: %s'
GAME_UNKNOWN_ORDER_TYPE = 'UNKNOWN ORDER TYPE: %s'
GAME_FORBIDDEN_RULE = 'RULE %s PREVENTS RULE %s FROM BEING APPLIED.'
GAME_UNRECOGNIZED_ORDER_DATA = 'UNRECOGNIZED DATA IN ORDER: %s'
GAME_AMBIGUOUS_PLACE_NAME = 'AMBIGUOUS PLACENAME: %s'
GAME_BAD_PHASE_NOT_IN_FLOW = 'BAD PHASE (NOT IN FLOW)'
GAME_BAD_BEGIN_PHASE = 'BAD BEGIN PHASE'
GAME_BAD_YEAR_GAME_PHASE = 'BAD YEAR IN GAME PHASE'
GAME_BAD_ADJUSTMENT_ORDER = 'BAD ADJUSTMENT ORDER: %s'
GAME_BAD_RETREAT = 'BAD RETREAT FOR %s: %s'
GAME_ORDER_TO_INVALID_UNIT = 'ORDER TO INVALID UNIT: %s'
GAME_ORDER_INCLUDES_INVALID_UNIT = 'ORDER INCLUDES INVALID UNIT: %s'
GAME_ORDER_INCLUDES_INVALID_DEST = 'ORDER INCLUDES INVALID UNIT DESTINATION %s'
GAME_ORDER_NON_EXISTENT_UNIT = 'ORDER TO NON-EXISTENT UNIT: %s'
GAME_ORDER_TO_FOREIGN_UNIT = 'ORDER TO FOREIGN UNIT: %s'
GAME_UNIT_MAY_ONLY_HOLD = 'UNIT MAY ONLY BE ORDERED TO HOLD: %s'
GAME_CONVOY_IMPROPER_UNIT = 'CONVOY ORDER FOR IMPROPER UNIT: %s %s'
GAME_INVALID_ORDER_NON_EXISTENT_UNIT = 'CANNOT %s NON-EXISTENT UNIT: %s %s'
GAME_INVALID_ORDER_RECIPIENT = 'INVALID %s RECIPIENT: %s %s'
GAME_BAD_ORDER_SYNTAX = 'BAD %s ORDER: %s %s'
GAME_ORDER_RECIPIENT_DOES_NOT_EXIST = '%s RECIPIENT DOES NOT EXIST: %s %s'
GAME_UNIT_CANT_SUPPORT_ITSELF = 'UNIT CANNOT SUPPORT ITSELF: %s %s'
GAME_UNIT_CANT_BE_CONVOYED = 'UNIT CANNOT BE CONVOYED: %s %s'
GAME_BAD_CONVOY_DESTINATION = 'BAD CONVOY DESTINATION: %s %s'
GAME_SUPPORTED_UNIT_CANT_REACH_DESTINATION = 'SUPPORTED UNIT CANNOT REACH DESTINATION: %s %s'
GAME_UNIT_CANT_PROVIDE_SUPPORT_TO_DEST = 'UNIT CANNOT PROVIDE SUPPORT TO DESTINATION: %s %s'
GAME_IMPROPER_CONVOY_ORDER = 'IMPROPER CONVOY ORDER: %s %s'
GAME_IMPROPER_SUPPORT_ORDER = 'IMPROPER SUPPORT ORDER: %s %s'
GAME_IMPOSSIBLE_CONVOY_ORDER = 'IMPOSSIBLE CONVOY ORDER: %s %s'
GAME_BAD_MOVE_ORDER = 'BAD MOVE ORDER: %s %s'
GAME_UNIT_CANT_CONVOY = 'UNIT CANNOT CONVOY: %s %s'
GAME_MOVING_UNIT_CANT_RETURN = 'MOVING UNIT MAY NOT RETURN: %s %s'
GAME_CONVOYING_UNIT_MUST_REACH_COST = 'CONVOYING UNIT MUST REACH COAST: %s %s'
GAME_ARMY_CANT_CONVOY_TO_COAST = 'ARMY CANNOT CONVOY TO SPECIFIC COAST: %s %s'
GAME_CONVOY_UNIT_USED_TWICE = 'CONVOYING UNIT USED TWICE IN SAME CONVOY: %s %s'
GAME_UNIT_CANT_MOVE_INTO_DEST = 'UNIT CANNOT MOVE INTO DESTINATION: %s %s'
GAME_UNIT_CANT_MOVE_VIA_CONVOY_INTO_DEST = 'UNIT CANNOT MOVE VIA CONVOY INTO DESTINATION: %s %s'
GAME_BAD_CONVOY_MOVE_ORDER = 'BAD CONVOY MOVE ORDER: %s %s'
GAME_CONVOY_THROUGH_NON_EXISTENT_UNIT = 'CONVOY THROUGH NON-EXISTENT UNIT: %s %s'
GAME_IMPOSSIBLE_CONVOY = 'IMPOSSIBLE CONVOY: %s %s'
GAME_INVALID_HOLD_ORDER = 'INVALID HOLD ORDER: %s %s'
GAME_UNRECOGNIZED_ORDER_TYPE = 'UNRECOGNIZED ORDER TYPE: %s %s'
GAME_INVALID_RETREAT = 'INVALID RETREAT: %s - %s'
GAME_NO_CONTROL_OVER = 'NO CONTROL OVER %s'
GAME_UNIT_NOT_IN_RETREAT = 'UNIT NOT IN RETREAT: %s'
GAME_TWO_ORDERS_FOR_RETREATING_UNIT = 'TWO ORDERS FOR RETREATING UNIT: %s'
GAME_INVALID_RETREAT_DEST = 'INVALID RETREAT DESTINATION: %s'
GAME_BAD_RETREAT_ORDER = 'BAD RETREAT ORDER: %s'
GAME_DATA_FOR_NON_POWER = 'DATA FOR NON-POWER: %s'
GAME_UNABLE_TO_FIND_RULES = 'UNABLE TO FIND FILE CONTAINING RULES.'
GAME_BUILDS_IN_ALL_ALT_SITES = 'BUILDS IN ALL ALTERNATIVE SITES (%s): %s'
GAME_NO_SUCH_UNIT = 'NO SUCH UNIT: %s'
GAME_MULTIPLE_ORDERS_FOR_UNIT = 'MULTIPLE ORDERS FOR UNIT: %s'
GAME_INVALID_BUILD_SITE = 'INVALID BUILD SITE: %s'
GAME_MULT_BUILDS_IN_SITE = 'MULTIPLE BUILDS IN SITE: %s'
GAME_INVALID_BUILD_ORDER = 'INVALID BUILD ORDER: %s'
GAME_EXCESS_HOME_CENTER_CLAIM = 'EXCESS HOME CENTER CLAIM'

STD_GAME_BAD_ORDER = 'BAD ORDER: %s'
STD_GAME_UNIT_REORDERED = 'UNIT REORDERED: %s'
STD_GAME_UNORDERABLE_UNIT = 'UNORDERABLE UNIT: %s'
